package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.Pixmap;
import com.badlogic.gdx.graphics.Pixmap.Format;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.scenes.scene2d.ui.Image;
import com.badlogic.gdx.utils.Disposable;

import zero1hd.rhythmbullet.audio.visualizer.MirrorVisualizer;

public class TitleBarVisualizer extends Group implements Disposable {
	private Visualizer visual;
	private MirrorVisualizer visual2;
	private Texture bgTexture;
	private Image bg;
	public TitleBarVisualizer(AssetManager assets, OrthographicCamera camera) {
		if (assets == null) throw new  NullPointerException("TitleBarVisualizer requires assets manager... ITS NULL YOU FOOL");
		visual = new Visualizer();
		visual.getVis().setSpaceBetweenBars(visual.getVis().getBarWidth()-1);
		addActor(visual);
		
		setSize(Gdx.graphics.getWidth(), Gdx.graphics.getHeight()*0.2f);
		setPosition(0, (Gdx.graphics.getHeight()-getHeight())/2f);
		visual.setWidth(getWidth());
		visual.setHeight(getHeight());
		visual.setY(-2);
		visual.getVis().flip();
		visual.getVis().reverse();
		visual2 = new MirrorVisualizer();
		visual.getVis().addMirrorVisualizer(visual2);
		visual2.setyPos(MathUtils.round(getHeight()));
		
		Pixmap pixmap = new Pixmap(2, 2, Format.RGBA8888);
		pixmap.setColor(Color.WHITE);
		pixmap.fill();
		bgTexture = new Texture(pixmap);
		pixmap.dispose();
		
		bg = new Image(bgTexture);
		bg.setSize(getWidth(), getHeight());
		addActor(bg);
	}
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		super.draw(batch, parentAlpha);
	}
	
	public Visualizer getHvisual() {
		return visual;
	}

	@Override
	public void dispose() {
		bgTexture.dispose();
	}
	
	@Override
	public void setColor(Color color) {
		super.setColor(color);
	}
	
	@Override
	public void setColor(float r, float g, float b, float a) {
		super.setColor(r, g, b, a);
	}
}
